
namespace FileTypeAssociation
{
    public class ProgramToUse
    {
        #region fields

        private string _name;
        private string _path;

        #endregion
        #region accessors

        /// <summary>
        /// Gets this ProgramToUse's Name
        /// </summary>
        public string Name 
        {
            get { return _name; }
        }

        /// <summary>
        /// Gets this ProgramToUse's Path
        /// </summary>
        public string Path
        {
            get { return _path; }
        }

        #endregion
        #region constructor

        /// <summary>
        /// Initializes a new instance of ProgramToUse
        /// </summary>
        /// <param name="name">The name of the ProgramToUse</param>
        /// <param name="path">The path of the ProgramToUse</param>
        public ProgramToUse(string name, string path) 
        {
            _name = name;
            _path = path;
        }

        #endregion
        #region methods
        
        /// <summary>
        /// Serves as a hash function for a particular type
        /// </summary>
        /// <returns>This instances hash</returns>
        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        /// <summary>
        /// Determines if this ProgramToUse is equal to that object
        /// </summary>
        /// <param name="obj">The object to check for equality</param>
        /// <returns>Whether the object is an ProgramToUse with the same path as this</returns>
        public override bool Equals(object obj)
        {
            // if they're the same type, cast them to compare further
            // else they're not equal
            if (obj.GetType() == typeof(ProgramToUse))
            {
                ProgramToUse that = (obj as ProgramToUse);
                return _path.Equals(that.Path);
            }
            return false;
        }

        /// <summary>
        /// Gets a string that represents this ProgramToUse
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            //return string.Format("{0} | {1}", _name, _path);
            return _name;
        }

        #endregion
    }
}
